ath10k_pci crashing

Bug #1818881 reported by Stephan Fabel on 2019-03-06
44
This bug affects 6 people
Affects Status Importance Assigned to Milestone
OEM Priority Project
High
Alex Tu
linux (Ubuntu)
High
Unassigned

Bug Description

The below happens on a regular basis on my DELL XPS 13 9380:

[77451.338493] RIP: 0010:ath10k_htt_rx_pop_paddr.isra.29+0xd9/0xf0 [ath10k_core]
[77451.338494] Code: 74 32 48 8b 87 10 02 00 00 48 85 c0 74 26 48 8b 40 28 48 85 c0 74 17 45 31 c0 b9 02 00 00 00 e8 dd c1 d7 db 48 89 d8 5b 5d c3 <0f> 0b 31 db 48 89 d8 5b 5d c3 48 8b 05 de 67 5a dc eb d1 0f 1f 40
[77451.338531] RSP: 0018:ffff9d996e503d78 EFLAGS: 00010246
[77451.338533] RAX: 0000000000000000 RBX: ffff9d97b7c12290 RCX: ffff9d96cbfd5528
[77451.338534] RDX: 0000000037af2804 RSI: ffff9d9944c51ed4 RDI: ffff9d9944c51de0
[77451.338535] RBP: ffff9d996e503d80 R08: 0000000000200000 R09: 0000000000000000
[77451.338537] R10: ffff9d94f045ecd8 R11: 00000000000001ff R12: ffff9d9944c51520
[77451.338538] R13: ffff9d996e503e40 R14: 0000000000000040 R15: ffff9d996e503e28
[77451.338540] FS: 0000000000000000(0000) GS:ffff9d996e500000(0000) knlGS:0000000000000000
[77451.338541] CS: 0010 DS: 0000 ES: 0000 CR0: 0000000080050033
[77451.338542] CR2: 00001f1104c31000 CR3: 000000017aa0a005 CR4: 00000000003606e0
[77451.338543] Call Trace:
[77451.338545] <IRQ>
[77451.338557] ath10k_htt_txrx_compl_task+0x3d6/0xe40 [ath10k_core]
[77451.338561] ? ath10k_pci_irq_msi_fw_unmask+0x70/0x70 [ath10k_pci]
[77451.338563] ? ath10k_pci_wake.part.24+0xa0/0xa0 [ath10k_pci]
[77451.338567] ath10k_pci_napi_poll+0x54/0x110 [ath10k_pci]
[77451.338571] net_rx_action+0x140/0x3a0
[77451.338575] __do_softirq+0xe4/0x2d4
[77451.338580] irq_exit+0xc5/0xd0
[77451.338582] do_IRQ+0x8a/0xe0
[77451.338585] common_interrupt+0xf/0xf
[77451.338586] </IRQ>
[77451.338589] RIP: 0010:cpuidle_enter_state+0xa5/0x2c0
[77451.338590] Code: 8b 3d df bf 9d 63 e8 6a 09 89 ff 48 89 c3 0f 1f 44 00 00 31 ff e8 cb 14 89 ff 45 84 ff 0f 85 c8 01 00 00 fb 66 0f 1f 44 00 00 <48> 2b 5d d0 48 ba cf f7 53 e3 a5 9b c4 20 48 89 d8 48 c1 fb 3f 48
[77451.338621] RSP: 0018:ffffaf4601993e50 EFLAGS: 00000246 ORIG_RAX: ffffffffffffffde
[77451.338623] RAX: ffff9d996e522c40 RBX: 000046710b80e2b6 RCX: 000000000000001f
[77451.338624] RDX: 000046710b80e2b6 RSI: 000000004041cc98 RDI: 0000000000000000
[77451.338625] RBP: ffffaf4601993e90 R08: 0000000000000002 R09: 00000000000224c0
[77451.338626] R10: ffffaf4601993e20 R11: 00000000000000d9 R12: 0000000000000004
[77451.338626] R13: ffff9d996e52ce00 R14: ffffffff9d3849f8 R15: 0000000000000000
[77451.338630] cpuidle_enter+0x17/0x20
[77451.338632] call_cpuidle+0x23/0x40
[77451.338634] do_idle+0x204/0x280
[77451.338636] cpu_startup_entry+0x73/0x80
[77451.338639] start_secondary+0x1ab/0x200
[77451.338642] secondary_startup_64+0xa5/0xb0
[77451.338643] ---[ end trace 22914e3b3a848f81 ]---
[77451.338655] ath10k_pci 0000:02:00.0: failed to pop paddr list: -2

$ uname -a
Linux perseus 4.18.0-15-generic #16~18.04.1-Ubuntu SMP Thu Feb 7 14:06:04 UTC 2019 x86_64 x86_64 x86_64 GNU/Linux

$ modinfo ath10k_pci
filename: /lib/modules/4.18.0-15-generic/kernel/drivers/net/wireless/ath/ath10k/ath10k_pci.ko
firmware: ath10k/QCA9377/hw1.0/board.bin
firmware: ath10k/QCA9377/hw1.0/firmware-5.bin
firmware: ath10k/QCA9377/hw1.0/firmware-6.bin
firmware: ath10k/QCA6174/hw3.0/board-2.bin
firmware: ath10k/QCA6174/hw3.0/board.bin
firmware: ath10k/QCA6174/hw3.0/firmware-6.bin
firmware: ath10k/QCA6174/hw3.0/firmware-5.bin
firmware: ath10k/QCA6174/hw3.0/firmware-4.bin
firmware: ath10k/QCA6174/hw2.1/board-2.bin
firmware: ath10k/QCA6174/hw2.1/board.bin
firmware: ath10k/QCA6174/hw2.1/firmware-5.bin
firmware: ath10k/QCA6174/hw2.1/firmware-4.bin
firmware: ath10k/QCA9887/hw1.0/board-2.bin
firmware: ath10k/QCA9887/hw1.0/board.bin
firmware: ath10k/QCA9887/hw1.0/firmware-5.bin
firmware: ath10k/QCA988X/hw2.0/board-2.bin
firmware: ath10k/QCA988X/hw2.0/board.bin
firmware: ath10k/QCA988X/hw2.0/firmware-5.bin
firmware: ath10k/QCA988X/hw2.0/firmware-4.bin
firmware: ath10k/QCA988X/hw2.0/firmware-3.bin
firmware: ath10k/QCA988X/hw2.0/firmware-2.bin
license: Dual BSD/GPL
description: Driver support for Qualcomm Atheros 802.11ac WLAN PCIe/AHB devices
author: Qualcomm Atheros
srcversion: D49EBAB0107B6CE28383BB8
alias: pci:v0000168Cd00000050sv*sd*bc*sc*i*
alias: pci:v0000168Cd00000042sv*sd*bc*sc*i*
alias: pci:v0000168Cd00000046sv*sd*bc*sc*i*
alias: pci:v0000168Cd00000056sv*sd*bc*sc*i*
alias: pci:v0000168Cd00000040sv*sd*bc*sc*i*
alias: pci:v0000168Cd0000003Esv*sd*bc*sc*i*
alias: pci:v0000168Cd00000041sv*sd*bc*sc*i*
alias: pci:v0000168Cd0000003Csv*sd*bc*sc*i*
alias: pci:v00000777d000011ACsv*sd*bc*sc*i*
depends: ath10k_core
retpoline: Y
intree: Y
name: ath10k_pci
vermagic: 4.18.0-15-generic SMP mod_unload
signat: PKCS#7
signer:
sig_key:
sig_hashalgo: md4
parm: irq_mode:0: auto, 1: legacy, 2: msi (default: 0) (uint)
parm: reset_mode:0: auto, 1: warm only (default: 0) (uint)

$ lspci | grep -i atheros
02:00.0 Network controller: Qualcomm Atheros QCA6174 802.11ac Wireless Network Adapter (rev 32)

I've updated the firmware manually as a first step trying to resolve the issue per
https://www.dell.com/community/Linux-Developer-Systems/XPS-13-9370-ath10k-pci-firmware-crash/td-p/6114945

I'm not sure whether this is related to https://bugs.launchpad.net/ubuntu/+source/linux/+bug/1730331

but it doesn't seem to have been resolved. As a side-note, seems as if linux-firmware doesn't ship the latest for the QCA6174.
---
ProblemType: Bug
ApportVersion: 2.20.9-0ubuntu7.5
Architecture: amd64
AudioDevicesInUse:
 USER PID ACCESS COMMAND
 /dev/snd/controlC0: stephan 2978 F.... pulseaudio
 /dev/snd/controlC2: stephan 2978 F.... pulseaudio
 /dev/snd/controlC1: stephan 2978 F.... pulseaudio
CurrentDesktop: ubuntu:GNOME
DistroRelease: Ubuntu 18.04
HibernationDevice: RESUME=UUID=75c252d4-dee6-4b0f-9ed2-0ac33d36b273
InstallationDate: Installed on 2019-02-04 (29 days ago)
InstallationMedia: Ubuntu 18.04 LTS "Bionic Beaver" - Release amd64 (20180426)
MachineType: Dell Inc. XPS 13 9380
NonfreeKernelModules: zfs zunicode zavl icp zcommon znvpair
Package: linux (not installed)
ProcFB: 0 inteldrmfb
ProcKernelCmdLine: BOOT_IMAGE=/vmlinuz-4.18.0-15-generic root=/dev/mapper/ubuntu--vg-root ro quiet splash vt.handoff=1
ProcVersionSignature: Ubuntu 4.18.0-15.16~18.04.1-generic 4.18.20
RelatedPackageVersions:
 linux-restricted-modules-4.18.0-15-generic N/A
 linux-backports-modules-4.18.0-15-generic N/A
 linux-firmware 1.173.3
Tags: bionic
Uname: Linux 4.18.0-15-generic x86_64
UpgradeStatus: No upgrade log present (probably fresh install)
UserGroups: adm cdrom dip lpadmin lxd plugdev root sambashare sudo
_MarkForUpload: True
dmi.bios.date: 01/08/2019
dmi.bios.vendor: Dell Inc.
dmi.bios.version: 1.1.1
dmi.board.name: 0KTW76
dmi.board.vendor: Dell Inc.
dmi.board.version: A00
dmi.chassis.type: 10
dmi.chassis.vendor: Dell Inc.
dmi.modalias: dmi:bvnDellInc.:bvr1.1.1:bd01/08/2019:svnDellInc.:pnXPS139380:pvr:rvnDellInc.:rn0KTW76:rvrA00:cvnDellInc.:ct10:cvr:
dmi.product.family: XPS
dmi.product.name: XPS 13 9380
dmi.product.sku: 08AF
dmi.sys.vendor: Dell Inc.

Colin Watson (cjwatson) on 2019-03-06
affects: launchpad → linux (Ubuntu)

This bug is missing log files that will aid in diagnosing the problem. While running an Ubuntu kernel (not a mainline or third-party kernel) please enter the following command in a terminal window:

apport-collect 1818881

and then change the status of the bug to 'Confirmed'.

If, due to the nature of the issue you have encountered, you are unable to run this command, please add a comment stating that fact and change the bug status to 'Confirmed'.

This change has been made by an automated script, maintained by the Ubuntu Kernel Team.

Changed in linux (Ubuntu):
status: New → Incomplete
tags: added: cosmic

apport information

tags: added: apport-collected bionic
description: updated

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

Stephan Fabel (sfabel) on 2019-03-07
Changed in linux (Ubuntu):
status: Incomplete → Confirmed
Kai-Heng Feng (kaihengfeng) wrote :

Would it be possible for you to test the latest upstream kernel? Refer
to https://wiki.ubuntu.com/KernelMainlineBuilds . Please test the latest
v5.0 kernel [0].

If this bug is fixed in the mainline kernel, please add the following
tag 'kernel-fixed-upstream'.

If the mainline kernel does not fix this bug, please add the tag:
'kernel-bug-exists-upstream'.

Once testing of the upstream kernel is complete, please mark this bug as
"Confirmed".

Thanks in advance.

[0] https://kernel.ubuntu.com/~kernel-ppa/mainline/v5.0/

Kai-Heng Feng (kaihengfeng) wrote :

This commit particular:
commit 85bd0107c6cd445a33066a57658fc585244a1100
Author: Yu Wang <email address hidden>
Date: Thu Dec 20 09:53:26 2018 +0200

    ath10k: add amsdu support for monitor mode

Changed in linux (Ubuntu):
assignee: nobody → Kai-Heng Feng (kaihengfeng)
Alex Tu (alextu) wrote :

@sfabel
thanks for your report.
Do you convenient help to get sosreport for us to clarify which generation of xps 13 for this issue?

The steps of getting sosreport is:
1. sudo apt-get install sosreport
2. sudo sosreport --batch --case-id xps13
3. upload the tarball generated here

Kai-Heng Feng (kaihengfeng) wrote :

dmi.product.name: XPS 13 9380?

If it's not enough we should let apport-collect collect more info.

Alex Tu (alextu) wrote :

I just got a XPS 13 9380, not find the issue yet, I'm keep using that machine wireless to see if I can reproduce here.

Not sure if the wireless chip same as the machine be reported.

hardware information:
02:00.0 Network controller [0280]: Qualcomm Atheros QCA6174 802.11ac Wireless Network Adapter [168c:003e] (rev 32)

uname -r:
4.18.0-16-generic
(4.18.0-16.17~18.04.1)

system ID:
08AF

$ modinfo ath10k_pci
http://paste.ubuntu.com/p/QXxkBR9Ymt/

Alex Tu (alextu) wrote :

I tried ping out for about 2 hours on the same machine (CID:201810-26508) of #12
But not see this issue yet, I will put the machine ping out for over weekend to see if I can reproduce this issue.

But I afraid the issue has been fixed by the new kernel (4.18.0-16.17~18.04.1).
Could you please try if updating kernel fix the issue on your machine?

Alex Tu (alextu) wrote :

the sosreport of the environment of #21 and #22.
On that environment, the wifi works well on that machine after over weekend ping out + youtube playing.

Alex Tu (alextu) wrote :

this morning, I also tried older released 18.04.2 image[1], which have the same older kernel 4.18.0-15-generic as this ticket description.

But, still not find ath10k error message after playing youtube for 2 hours.
I'll keep using that machine to see if I can reproduce this issue.

@Stephan,
Could you please try upgrade system to see if this issue can be fixed?
$ sudo apt-get update; sudo apt-get upgrade -y

[1] http://releases.ubuntu.com/18.04/

Hi

upgraded the system as instructed, FWIW here's the fwupdmgr output just to
confirm:

$ fwupdmgr update
No upgrades for XPS 13 9380 System Firmware, current is 0.1.2.1:
0.1.2.1=same, 0.1.1.1=older, 0.1.0.0=older

I had my xHCI controller die on me today as well:

[95279.564648] xhci_hcd 0000:39:00.0: xHCI host not responding to stop
endpoint command.
[95279.564656] xhci_hcd 0000:39:00.0: xHCI host controller not responding,
assume dead
[95279.564679] xhci_hcd 0000:39:00.0: HC died; cleaning up

I will now reboot and see whether this problem still occurs.

Thanks,
Stephan

On Sun, Mar 31, 2019 at 9:35 PM Alex Tu <email address hidden> wrote:

> this morning, I also tried older released 18.04.2 image[1], which have
> the same older kernel 4.18.0-15-generic as this ticket description.
>
> But, still not find ath10k error message after playing youtube for 2 hours.
> I'll keep using that machine to see if I can reproduce this issue.
>
> @Stephan,
> Could you please try upgrade system to see if this issue can be fixed?
> $ sudo apt-get update; sudo apt-get upgrade -y
>
>
> [1] http://releases.ubuntu.com/18.04/
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1818881
>
> Title:
> ath10k_pci crashing
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/oem-priority/+bug/1818881/+subscriptions
>

Pascal Morin (pcm689) on 2019-04-02
Changed in oem-priority:
assignee: nobody → Alex Tu (alextu)
status: New → Triaged
Alex Tu (alextu) wrote :

shared more information from Stephan,
"
so just to be clear, I often times am able to stay on 5 hours on a Meet with no problem
then it just starts happening and I can't seem to get out of it
"

and the machine is also plugged AC power while meeting.

I also followed the way to test google hangout video call + youtube playing over 6 hours on the same environment of #24 which the XPS 13 I have, but no luck to reproduce that here so far.

Stephan Fabel (sfabel) wrote :

I've reset the machine with the latest OEM image to retest. I am now experiencing system freezes at random times. I've generated a new sosreport and am attaching it to this case.

Kai-Heng Feng (kaihengfeng) wrote :

From what I can understand it can be a firmware bug.
The AM{P,S}DU data was read from firmware (via DMA) and get hashed. When the driver tries to assemble it in order, the address isn't in the hash.

So please try latest upstream firmware from [1], replace /lib/firmware/ath10k/QCA6174/hw3.0/firmware-6.bin and /lib/firmware/ath10k/QCA6174/hw3.0/board-2.bin.

If [1] doesn't work, try the latest ath10k firmware [2], and replace /lib/firmware/ath10k/QCA6174/hw3.0/firmware-6.bin with QCA6174/hw3.0/4.4.1.c3/firmware-6.bin_RM.4.4.1.c3-00013-QCARMSWPZ-1. Also ath10k-firmware/QCA6174/hw3.0/board-2.bin

[1] git://git.kernel.org/pub/scm/linux/kernel/git/firmware/linux-firmware.git
[2] https://github.com/kvalo/ath10k-firmware.git

Alex Tu (alextu) wrote :

for record.
sosreport got from OEM image X37_A02 on ITAW-DVT2-C3 (201810-26509)

Anthony Wong (anthonywong) wrote :

@Stephan

Following comment #28, I have re-packaged linux-firmware package to include the firmwares from the two upstreams:

[1] https://people.canonical.com/~ypwong/lp1818881/linux-firmware_1.173.3test1_all.deb
[2] https://people.canonical.com/~ypwong/lp1818881/linux-firmware_1.173.3test2_all.deb

You can grab them and use dpkg -i to install them.

Changed in oem-priority:
importance: Undecided → High
Changed in linux (Ubuntu):
importance: Undecided → High
tags: added: hwe
Changed in linux (Ubuntu):
assignee: Kai-Heng Feng (kaihengfeng) → nobody
Daniel C (djcater) wrote :

I have a 2019 Dell XPS 13 (9380). I bought the Developer Edition from Dell which came with Ubuntu 18.04.

I recently wiped it and installed 19.04 fresh from the ISO.

I am also getting Wi-Fi crashes.

This is the chip (from sudo lspci -vvv) which is the same as the one listed by the reporter of this bug:

02:00.0 Network controller: Qualcomm Atheros QCA6174 802.11ac Wireless Network Adapter (rev 32)
 Subsystem: Bigfoot Networks, Inc. QCA6174 802.11ac Wireless Network Adapter (Killer 1435 Wireless-AC)

And the kernel:

Linux daniel-XPS-13-9380 5.0.0-13-generic #14-Ubuntu SMP Mon Apr 15 14:59:14 UTC 2019 x86_64 x86_64 x86_64 GNU/Linux

I will try and capture some logs next time it happens and upload them here.

ProblemType: Bug
ApportVersion: 2.20.10-0ubuntu27
Architecture: amd64
AudioDevicesInUse:
 USER PID ACCESS COMMAND
 /dev/snd/controlC0: daniel 1740 F.... pulseaudio
CurrentDesktop: ubuntu:GNOME
DistroRelease: Ubuntu 19.04
InstallationDate: Installed on 2019-04-28 (13 days ago)
InstallationMedia: Ubuntu 19.04 "Disco Dingo" - Release amd64 (20190416)
MachineType: Dell Inc. XPS 13 9380
Package: linux (not installed)
ProcFB: 0 inteldrmfb
ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-5.0.0-13-generic root=UUID=fcb75d61-4e46-4391-8800-ccef7ff04f70 ro quiet splash vt.handoff=1
ProcVersionSignature: Ubuntu 5.0.0-13.14-generic 5.0.6
RelatedPackageVersions:
 linux-restricted-modules-5.0.0-13-generic N/A
 linux-backports-modules-5.0.0-13-generic N/A
 linux-firmware 1.178
Tags: disco
Uname: Linux 5.0.0-13-generic x86_64
UpgradeStatus: No upgrade log present (probably fresh install)
UserGroups: adm cdrom dip libvirt lpadmin plugdev sambashare sudo
_MarkForUpload: True
dmi.bios.date: 03/29/2019
dmi.bios.vendor: Dell Inc.
dmi.bios.version: 1.3.2
dmi.board.name: 0KTW76
dmi.board.vendor: Dell Inc.
dmi.board.version: A00
dmi.chassis.type: 10
dmi.chassis.vendor: Dell Inc.
dmi.modalias: dmi:bvnDellInc.:bvr1.3.2:bd03/29/2019:svnDellInc.:pnXPS139380:pvr:rvnDellInc.:rn0KTW76:rvrA00:cvnDellInc.:ct10:cvr:
dmi.product.family: XPS
dmi.product.name: XPS 13 9380
dmi.product.sku: 08AF
dmi.sys.vendor: Dell Inc.

tags: added: disco

apport information

Daniel C (djcater) wrote : CRDA.txt

apport information

apport information

apport information

Daniel C (djcater) wrote : Lspci.txt

apport information

Daniel C (djcater) wrote : Lsusb.txt

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

Daniel C (djcater) wrote :

I've attached logs from my XPS 13 (9380) with the same wireless chipset (Qualcomm Atheros QCA6174).

Suspending and resuming triggered the crash. This time, it seemed to be a recoverable crash (I was able to browse here without rebooting). But sometimes the machine is in a unrecoverable state (running any command in the terminal just seems to hang) and I have to hold the power button for 8 seconds to force it to turn off.

Rex Tsai (chihchun) on 2019-07-16
tags: added: ath10k
Brad Figg (brad-figg) on 2019-07-24
tags: added: ubuntu-certified
Daniel C (djcater) wrote :

I still hit this issue a few times per week, usually after resuming from suspend.

I've attached the dmesg output from the most recent one (today). In this instance, although the Wi-Fi was not working, I was still able to interact with the system and shut it down cleanly. That's not always the case - sometimes the running system is corrupted and I can't even shutdown cleanly but have to do a hard power-off with the power button.

This is with all the latest updates applied on 19.04.

Kernel: Linux daniel-XPS-13-9380 5.0.0-21-generic #22-Ubuntu SMP Tue Jul 2 13:27:33 UTC 2019 x86_64 x86_64 x86_64 GNU/Linux

Is there anything in the pipeline that will help with this? Any contacts at Dell, or Qualcomm / Atheros?

This is after all a certified Ubuntu laptop.

Daniel C (djcater) wrote :
Alex Tu (alextu) wrote :

from #31, the wifi should work well on preload image 18.04+oem kernel 4.15(also refer to [1]), so it could be a regression on non-LTS Ubuntu. In this case, the crash could be caused by a kernel regression or some binary in linux-firmware.

On non-LTS Ubuntu, there are some ways can be tried.

OEM kernel:
 - refer to this post [2], the machine is certified by OEM kernel, so OEM kernel is supposed to works well on device function.
 - https://bugs.launchpad.net/ubuntu/+source/linux-oem-osp1
 - https://bugs.launchpad.net/ubuntu/+source/linux-oem

mainline kernel:
 - the latest mainline kernel should already include most of the existed fix.
 - https://kernel.ubuntu.com/~kernel-ppa/mainline/
 - a script to help you install it: https://github.com/fourdollars/scripts/blob/master/mainline-kernels.sh

latest linux-firmware:
 - the one you are using looks already the latest one [3]

most of device function failure is supposed to be fixed by the mainline kernel or OEM kernel, then it might take some time to land it to the generic kernel.

BTW, I once test a 9380 by the way of [2], wifi worked well on the combination kernel linux-image-4.15.0-1045-oem + linux-firmware 1.173.9 (more detail about my system information [4]).

Compare the dmesg to yours, the firmware of wifi module looks difference, it could be a clue.
Mine : ath10k_pci 0000:02:00.0: firmware ver WLAN.RM.4.4.1-00079-QCARMSWPZ-1 api 6 features wowlan,ignore-otp crc32 fd869beb
Yours : ath10k_pci 0000:02:00.0: firmware ver RM.4.4.1.c2-00057-QCARMSWP-1 api 6 features wowlan,ignore-otp,no-4addr-pad,raw-mode crc32 e061250a

[1] https://certification.ubuntu.com/hardware/201810-26512/
[2] https://alex-tu-cc.github.io/2019/07/buy-a-certified-ubuntu-machine/
[3] https://qa.debian.org/madison.php?package=linux-firmware&table=ubuntu&a=&c=&s=#
[4] https://bugs.launchpad.net/ubuntu/+source/xorg-server/+bug/1837683

To post a comment you must log in.